
function count_members ( arr ) {
  var members = {};
  arr.forEach( function ( member ) {
    hash = fn.hash( member );
    members[ hash ] = members[ hash ] || 0;
    members[ hash ]++;
  });
  return members;
};

var fn = module.exports = {

/*
 * Tests whether obj2 is equal to obj1
 * If you want to test whether obj1 is equal to obj2,
 * write your own goddamn function
 */
deep: function ( obj2, obj1 ) {
  return fn.hash( obj2 ) === fn.hash( obj1 );
},

/*
 * Returns a hash that identifies the given object
 */
hash: function ( obj ) {
  var str = '';
  if ( obj instanceof Array ) {
    for ( var i = 0, l = obj.length; i < l; i++ ) {
      str += ',' + fn.hash( obj[ i ] );
    }
  } else if ( typeof obj === 'object' &&  obj !== null ) {
    Object.keys( obj ).sort().forEach( function ( key ) {
      str += ',' + fn.hash( key ) + '=' + fn.hash( obj[ key ] );
    });
  } else if ( typeof obj === 'string' ) {
    str = obj.replace( /,/g, '\\,' ).replace( /=/g, '\\=' ).replace(/:/g, '\\:');
  } else if ( typeof obj === 'number' ) {
    str = '=' + String( obj );
  } else if ( typeof obj === 'boolean' ) {
    str = obj ? '=true' : '=false';
  } else if ( obj === null ) {
    str = '=null';
  } else {
    str = String( obj );
  }
  return str;
},

/*
 * Returns true if the two given lists contain the same
 * items, regardless of order
 */
members: function ( arr1, arr2 ) {
  return fn.deep( count_members( arr1 ), count_members( arr2 ) );
},

/*
 * Returns true if the two given objects are of the same type
 */
type: function ( obj1, obj2 ) {
  return obj1.__proto__ == obj2.__proto__;
}


};

