var vows = require( 'vows' ),
    assert = require( 'assert' ),
    equality = require( '../lib/equality' );

vows.describe( 'type()' ).addBatch({

  'works': {

    topic: function () { return equality.type; },

    'with atomic values': function ( type ) {
      // numbers
      assert.isTrue( type( 1, 2 ) );
      assert.isTrue( type( 4.5, 1 ) );

      // numbers and strings
      assert.isFalse( type( 1, '1' ) );
      assert.isFalse( type( '1', 1 ) );

      // numbers and booleans
      assert.isFalse( type( 1, true ) );
      assert.isFalse( type( true, 1 ) );

      // booleans
      assert.isTrue( type( true, true ) );
      assert.isTrue( type( true, false ) );

      // booleans and strings
      assert.isFalse( type( true, 'true' ) );
      assert.isFalse( type( 'true', true ) );
    },

    'with "class instances"': function ( type ) {
      function A () {};
      function B () {};

      var a = new A(),
          a2 = new A(),
          b = new B();

      assert.isTrue( type( a, a2 ) );
      assert.isFalse( type( a, b ) );
    }

  }

}).export( module );
